﻿using System;

namespace TestProject
{
    /// <summary>
    /// 불린 포매터
    /// </summary>
    public class BooleanFormatter : IFormatProvider, ICustomFormatter
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// TRUE 문자열
        /// </summary>
        private string trueString;
        
        /// <summary>
        /// FALSE 문자열
        /// </summary>
        private string falseString;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - BooleanFormatter(trueString, falseString)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="trueString">TRUE 문자열</param>
        /// <param name="falseString">FALSE 문자열</param>
        public BooleanFormatter(string trueString, string falseString)
        {
            this.trueString  = trueString;
            this.falseString = falseString;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 포맷 구하기 - GetFormat(type)

        /// <summary>
        /// 포맷 구하기
        /// </summary>
        /// <param name="type">타입</param>
        /// <returns>포맷</returns>
        public object GetFormat(Type type)
        { 
            return this;
        }

        #endregion
        #region 포맷하기 - Format(formatString, argument, formatProvider)

        /// <summary>
        /// 포맷하기
        /// </summary>
        /// <param name="formatString">포맷 문자열</param>
        /// <param name="argument">인자</param>
        /// <param name="formatProvider">포맷 제공자</param>
        /// <returns>포맷 문자열</returns>
        public string Format(string formatString, object argument, IFormatProvider formatProvider)
        {
            bool formatValue = Convert.ToBoolean(argument);

            if(formatValue)
            {
                return trueString;
            }
            else
            {
                return falseString;
            }
        }

        #endregion
    }
}